﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;

namespace JaxPlugins
{

    /* --- © 2022 JaxZoa <JaxZoa@gmail.com> --- */

    public class JSONStorableVector
    {
        string name;

        JSONStorableFloat js_x, js_y, js_z;

        public JSONStorableVector(CLS _manager, string _name, Vector3 _startValue, bool _interactable = false)
        {
            name = _name;
            js_x = new JSONStorableFloat(name + "x", _startValue.x, -100000, 100000, false, _interactable);
            js_y = new JSONStorableFloat(name + "y", _startValue.y, -100000, 100000, false, _interactable);
            js_z = new JSONStorableFloat(name + "z", _startValue.z, -100000, 100000, false, _interactable);

            _manager.RegisterFloat(js_x);
            _manager.RegisterFloat(js_y);
            _manager.RegisterFloat(js_z);
        }

        public Vector3 val
        {
            get { return new Vector3(js_x.val, js_y.val, js_z.val); }

            set
            {
                js_x.val = value.x;
                js_y.val = value.y;
                js_z.val = value.z;
            }
        }

        public float x
        {
            get { return js_x.val; }

            set { js_x.val = value; }
        }

        public float y
        {
            get { return js_y.val; }

            set { js_y.val = value; }
        }

        public float z
        {
            get { return js_z.val; }

            set { js_z.val = value; }
        }
    }

}